diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
index 0493cf1ad..af61ec3ff 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
@@ -2,7 +2,7 @@ package net.minecraft.core.net.entity.entries;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.net.entity.EntityTracker;
 import net.minecraft.core.net.entity.EntityTrackerEntry;
 import net.minecraft.core.net.entity.ITrackedEntry;
@@ -12,10 +12,10 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class NetEntryMinecart implements IVehicleEntry<MinecartEntity>, ITrackedEntry<MinecartEntity> {
+public class NetEntryMinecart implements IVehicleEntry<EntityMinecart>, ITrackedEntry<EntityMinecart> {
     @Override
-    public @NotNull Class<MinecartEntity> getAppliedClass() {
-        return MinecartEntity.class;
+    public @NotNull Class<EntityMinecart> getAppliedClass() {
+        return EntityMinecart.class;
     }
 
     @Override
@@ -34,17 +34,23 @@ public class NetEntryMinecart implements IVehicleEntry<MinecartEntity>, ITracked
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, MinecartEntity trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityMinecart trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
-        return new MinecartEntity(world, x, y, z, metadata);
+        EntityMinecart minecartEntity = new EntityMinecart(world, x, y, z, metadata);
+        minecartEntity.setMeta(tag.getInteger("meta"));
+        minecartEntity.setFuel(tag.getShort("fuel"));
+        return minecartEntity;
     }
 
     @Override
-    public PacketAddEntity getSpawnPacket(EntityTrackerEntry tracker, MinecartEntity trackedObject) {
-        return new PacketAddEntity(trackedObject, trackedObject.type);
+    public PacketAddEntity getSpawnPacket(EntityTrackerEntry tracker, EntityMinecart trackedObject) {
+        CompoundTag extrasTag = new CompoundTag();
+        extrasTag.putInt("meta", trackedObject.getMeta());
+        extrasTag.putShort("fuel", trackedObject.getFuel());
+        return new PacketAddEntity(trackedObject, trackedObject.getType(), -1, null, null, null, extrasTag);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
index 8573791af..4ee257f4c 100644
--- a/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/handler/PacketHandler.java
@@ -33,6 +33,11 @@ public abstract class PacketHandler
         handleInvalidPacket(loginPacket);
     }
 
+    public void handlePlayerConfig(PacketPlayerConfig packetPlayerConfig)
+    {
+        handleInvalidPacket(packetPlayerConfig);
+    }
+
     public void handleFlying(PacketMovePlayer movePlayerPacket)
     {
         handleInvalidPacket(movePlayerPacket);
@@ -208,9 +213,9 @@ public abstract class PacketHandler
         handleInvalidPacket(containerClickPacket);
     }
 
-    public void handleTileEntityData(PacketBlockEntityData blockEntityDataPacket)
+    public void handleTileEntityData(PacketTileEntityData packetTileEntityData)
     {
-        handleInvalidPacket(blockEntityDataPacket);
+        handleInvalidPacket(packetTileEntityData);
     }
 
     public void handleSetSlot(PacketContainerSetSlot containerSetslotPacket)
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index 5fd4d72c0..f72654a17 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -285,6 +285,7 @@ public abstract class Packet
         addMapping(33, true, false, PacketMoveEntity.PosRot.class);
         addMapping(34, true, false, PacketTeleportEntity.class);
         addMapping(35, true, true, PacketEntityNickname.class);
+        addMapping(36, true, true, PacketPlayerConfig.class);
         addMapping(38, true, false, PacketEntityEvent.class);
         addMapping(39, true, false, PacketSetRiding.class);
         addMapping(40, true, false, PacketSetEntityData.class);
@@ -324,7 +325,7 @@ public abstract class Packet
         addMapping(137, false, true, PacketSetItemName.class);
         addMapping(138, true, false, PacketPlayerList.class);
         addMapping(139, false, true, PacketSetPaintingArt.class);
-        addMapping(140, true, false, PacketBlockEntityData.class);
+        addMapping(140, true, false, PacketTileEntityData.class);
         addMapping(142, true, false, PacketFlagOpen.class);
         addMapping(143, true, false, PacketPhotoMode.class);
         addMapping(200, true, false, PacketStatistic.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java
index 600b8f0be..e1d2d31d4 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java
@@ -31,6 +31,7 @@ public class PacketAddPlayer extends Packet
         currentItem = itemstack != null ? itemstack.itemID : 0;
         nickname = entityplayer.getDisplayName();
         chatColor = entityplayer.chatColor;
+        playerConfig = entityplayer.playerConfig.config;
         if (entityplayer.getHeldObject() == null) {
             heldObjectTag = null;
         } else {
@@ -55,6 +56,7 @@ public class PacketAddPlayer extends Packet
         currentItem = dis.readShort();
         nickname = readString(dis, MAX_NICKNAME_SIZE);
         chatColor = dis.readByte();
+        playerConfig = dis.readByte();
 
         if (dis.readByte() == 1) {
             heldObjectTag = readCompressedCompoundTag(dis);
@@ -78,6 +80,7 @@ public class PacketAddPlayer extends Packet
         dos.writeShort(currentItem);
         writeString(nickname, dos);
         dos.writeByte(chatColor);
+        dos.writeByte(playerConfig);
 
         if (heldObjectTag != null) {
             dos.writeByte(1);
@@ -111,4 +114,5 @@ public class PacketAddPlayer extends Packet
     public @Nullable CompoundTag heldObjectTag;
     public String nickname;
     public byte chatColor;
+    public byte playerConfig;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerConfig.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerConfig.java
new file mode 100644
index 000000000..bd5ea3cc2
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerConfig.java
@@ -0,0 +1,43 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class PacketPlayerConfig extends Packet {
+    public int entityId;
+    public byte config;
+    public PacketPlayerConfig() {}
+    public PacketPlayerConfig(Player.PlayerConfig config) {
+        this.entityId = -1;
+        this.config = config.config;
+    }
+    public PacketPlayerConfig(int entityId, Player.PlayerConfig config) {
+        this.entityId = entityId;
+        this.config = config.config;
+    }
+    @Override
+    public void read(DataInputStream dis) throws IOException {
+        entityId = dis.readInt();
+        config = dis.readByte();
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException {
+        dos.writeInt(entityId);
+        dos.writeByte(config);
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handlePlayerConfig(this);
+    }
+
+    @Override
+    public int getEstimatedSize() {
+        return 5;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEntityData.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketTileEntityData.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEntityData.java
rename to game/core/src/main/java/net/minecraft/core/net/packet/PacketTileEntityData.java
index 2c388caa0..1338b2d9d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketBlockEntityData.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketTileEntityData.java
@@ -6,17 +6,17 @@ import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
-public class PacketBlockEntityData
+public class PacketTileEntityData
     extends Packet
 {
     public CompoundTag tag;
 
-    public PacketBlockEntityData()
+    public PacketTileEntityData()
     {
         isChunkDataPacket = true;
     }
 
-    public PacketBlockEntityData(TileEntity tileEntity)
+    public PacketTileEntityData(TileEntity tileEntity)
     {
         this();
 
@@ -24,7 +24,7 @@ public class PacketBlockEntityData
         tileEntity.writeToNBT(tag);
     }
 
-    public PacketBlockEntityData(CompoundTag tag) {
+    public PacketTileEntityData(CompoundTag tag) {
         this.tag = tag;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
index f665658e9..c31ffea49 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
@@ -22,15 +22,15 @@ public class MenuFurnace extends MenuAbstract {
 	private int itemBurnTime;
 	private int itemCookTime;
 
-	public MenuFurnace(ContainerInventory inventory, TileEntityFurnace blockEntity) {
+	public MenuFurnace(ContainerInventory inventory, TileEntityFurnace tileEntity) {
 		currentCookTime = 0;
 		currentBurnTime = 0;
 		itemCookTime = 0;
 		itemBurnTime = 0;
-		furnace = blockEntity;
-		addSlot(new Slot(blockEntity, 0, 56, 17));
-		addSlot(new Slot(blockEntity, 1, 56, 53));
-		addSlot(new SlotFurnace(inventory.player, blockEntity, 2, 116, 35));
+		furnace = tileEntity;
+		addSlot(new Slot(tileEntity, 0, 56, 17));
+		addSlot(new Slot(tileEntity, 1, 56, 53));
+		addSlot(new SlotFurnace(inventory.player, tileEntity, 2, 116, 35));
 		for (int i = 0; i < 3; i++) {
 			for (int k = 0; k < 9; k++) {
 				addSlot(new Slot(inventory, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index aaf3943fa..0ac46ab45 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -83,7 +83,7 @@ public class MenuInventoryCreative extends MenuInventory
 		
 		for (int i = 0; i < creativeItemsCount; i++)
 		{
-			if (t.translateNameKey(creativeItems.get(i).getItemKey()).toLowerCase().contains(search.toLowerCase()))
+			if (t.translateKey(creativeItems.get(i).getItemKey() + ".name").toLowerCase().contains(search.toLowerCase()))
 			{
 				searchedItems.add(creativeItems.get(i));
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 5bd5de90d..89af7b7d0 100644
--- a/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/game/core/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -6,6 +6,7 @@ import org.jetbrains.annotations.NotNull;
 import java.util.Comparator;
 
 public final class NamespaceID implements Comparator<NamespaceID>, Comparable<NamespaceID> {
+    public static final String DEFAULT_NAMESPACE = "minecraft";
     public final String namespace;
     public final String value;
     public NamespaceID(String namespace, String value) throws IllegalArgumentException {
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index f1df137a7..fb71c4755 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -60,12 +60,12 @@ public class BlocksContainer implements WorldSource {
     }
 
     @Override
-    public TileEntity getBlockEntity(int x, int y, int z) {
+    public TileEntity getTileEntity(int x, int y, int z) {
         ChunkCoordinates c = new ChunkCoordinates(x, y, z);
         if (blockEntryMap.containsKey(c)){
             return blockEntryMap.get(c).tileEntity;
         }
-        return world.getBlockEntity(x, y, z);
+        return world.getTileEntity(x, y, z);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index c74e693f4..22450e328 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -67,7 +67,7 @@ public class Dimension
 	
 	public String getTranslatedName()
 	{
-		return I18n.getInstance().translateNameKey("dimension." + languageKey);
+		return I18n.getInstance().translateKey("dimension." + languageKey + ".name");
 	}
 	
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index efc1b3041..ebafd28f2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -65,7 +65,7 @@ public class Explosion {
             int z = chunkposition.z;
             
             int id = worldObj.getBlockId(x, y, z);
-            TileEntity tileEntity = worldObj.getBlockEntity(x, y, z);
+            TileEntity tileEntity = worldObj.getTileEntity(x, y, z);
             if(particles) {
                 double xPos = (double) x + worldObj.rand.nextFloat();
                 double yPos = (double) y + worldObj.rand.nextFloat();
diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index 4f9258d3f..d6982dd7b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -144,7 +144,7 @@ public class ExplosionCannonball extends Explosion{
             int y = chunkposition.y;
             int z = chunkposition.z;
             Block<?> block = worldObj.getBlock(x, y, z);
-            TileEntity tileEntity = worldObj.getBlockEntity(x, y, z);
+            TileEntity tileEntity = worldObj.getTileEntity(x, y, z);
             if(flag)
             {
                 double d = (double)x + worldObj.rand.nextFloat();
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 4f0b272f8..0f3e03456 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -63,6 +63,7 @@ import net.minecraft.core.world.saveddata.SavedData;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.weather.IPrecipitation;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.WeatherManager;
 import net.minecraft.core.world.weather.Weathers;
@@ -206,7 +207,6 @@ public class World implements WorldSource {
                 dimensionData.getCurrentWeather(),
                 dimensionData.getNextWeather(),
                 dimensionData.getWeatherDuration(),
-                dimensionData.getWeatherIntensity(),
                 dimensionData.getWeatherPower()
             );
         }
@@ -250,7 +250,6 @@ public class World implements WorldSource {
                 dimensionData.getCurrentWeather(),
                 dimensionData.getNextWeather(),
                 dimensionData.getWeatherDuration(),
-                dimensionData.getWeatherIntensity(),
                 dimensionData.getWeatherPower()
             );
         }
@@ -1769,7 +1768,7 @@ public class World implements WorldSource {
                 loadedTileEntityList.remove(i);
                 Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(tileEntity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileEntity.z, Chunk.CHUNK_SIZE_Z));
                 if (chunk != null) {
-                    chunk.removeBlockEntity(tileEntity);
+                    chunk.removeTileEntity(tileEntity);
                 }
             }
         }
@@ -2136,26 +2135,26 @@ public class World implements WorldSource {
     }
 
     @Override
-    public TileEntity getBlockEntity(int x, int y, int z)
+    public TileEntity getTileEntity(int x, int y, int z)
     {
         Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
         if(chunk != null)
         {
-            return chunk.getBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+            return chunk.getTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
         } else
         {
             return null;
         }
     }
 
-    public void setBlockTileEntity(int x, int y, int z, TileEntity tileEntity)
+    public void setTileEntity(int x, int y, int z, TileEntity tileEntity)
     {
         if(!tileEntity.isInvalid())
         {
             Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
             {
-                if (chunk.setBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), tileEntity) && !loadedTileEntityList.contains(tileEntity)) {
+                if (chunk.setTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), tileEntity) && !loadedTileEntityList.contains(tileEntity)) {
                     loadedTileEntityList.add(tileEntity);
                 }
             }
@@ -2164,7 +2163,7 @@ public class World implements WorldSource {
 
     public void removeBlockTileEntity(int x, int y, int z)
     {
-        TileEntity tileEntity = getBlockEntity(x, y, z);
+        TileEntity tileEntity = getTileEntity(x, y, z);
 
         if(tileEntity != null && updatingBlockEntities)
         {
@@ -2178,14 +2177,14 @@ public class World implements WorldSource {
             Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
             {
-                chunk.removeBlockEntity(tileEntity);
+                chunk.removeTileEntity(tileEntity);
             }
         }
     }
 
     public void replaceBlockTileEntity(int x, int y, int z, TileEntity tileEntity) {
         removeBlockTileEntity(x, y, z);
-        setBlockTileEntity(x, y, z, tileEntity);
+        setTileEntity(x, y, z, tileEntity);
     }
 
     @Override
@@ -2603,7 +2602,7 @@ public class World implements WorldSource {
         return loadedEntityList;
     }
 
-    public List<TileEntity> getLoadedBlockEntityList()
+    public List<TileEntity> getLoadedTileEntityList()
     {
         return loadedTileEntityList;
     }
@@ -3103,7 +3102,8 @@ public class World implements WorldSource {
                 entityplayer.wakeUpPlayer(false, false);
             }
         }
-        if (getCurrentWeather() != null && getCurrentWeather().spawnRainParticles)
+        final @Nullable Weather currentWeather = getCurrentWeather();
+        if (currentWeather instanceof IPrecipitation && ((IPrecipitation) currentWeather).spawnRainParticles())
         {
             weatherManager.overrideWeather(worldType.getDefaultWeather());
         }
@@ -3127,7 +3127,7 @@ public class World implements WorldSource {
         {
             return false;
         }
-        if (!getCurrentWeather().isPrecipitation)
+        if (!(getCurrentWeather() instanceof IPrecipitation))
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 6c036563b..6c4507283 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -15,7 +15,7 @@ public interface WorldSource
 
     @Nullable Block<?> getBlock(int x, int y, int z);
 
-    TileEntity getBlockEntity(int x, int y, int z);
+    TileEntity getTileEntity(int x, int y, int z);
 
     float getBrightness(int x, int y, int z, int blockLightValue);
     
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index fcf6285b9..b0f0fa846 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -30,7 +30,7 @@ public class Chunk
     public int lowestY;
     public final int xPosition;
     public final int zPosition;
-    public Map<ChunkPosition, TileEntity> blockEntityMap;
+    public Map<ChunkPosition, TileEntity> tileEntityMap;
     public double[] temperature;
     public double[] humidity;
     public double[] variety;
@@ -44,7 +44,7 @@ public class Chunk
 
     public Chunk(World world, int x, int z)
     {
-        blockEntityMap = new HashMap<>();
+        tileEntityMap = new HashMap<>();
         isTerrainPopulated = false;
         isModified = false;
         hasEntities = false;
@@ -489,10 +489,10 @@ public class Chunk
         return y >= getHeightValue(x, z);
     }
 
-    public TileEntity getBlockEntity(int x, int y, int z)
+    public TileEntity getTileEntity(int x, int y, int z)
     {
         ChunkPosition pos = new ChunkPosition(x, y, z);
-        TileEntity tileEntity = blockEntityMap.get(pos);
+        TileEntity tileEntity = tileEntityMap.get(pos);
         if(tileEntity == null)
         {
             Block<?> block = Blocks.getBlock(getBlockID(x, y, z));
@@ -501,11 +501,11 @@ public class Chunk
                 return null;
             }
             block.onBlockPlacedByWorld(world, xPosition * CHUNK_SIZE_X + x, y, zPosition * CHUNK_SIZE_Z + z);
-            tileEntity = blockEntityMap.get(pos);
+            tileEntity = tileEntityMap.get(pos);
         }
         if(tileEntity != null && tileEntity.isInvalid())
         {
-            blockEntityMap.remove(pos);
+            tileEntityMap.remove(pos);
             return null;
         }
         else
@@ -514,12 +514,12 @@ public class Chunk
         }
     }
 
-    public void addBlockEntity(TileEntity tileEntity)
+    public void addTileEntity(TileEntity tileEntity)
     {
         int x = tileEntity.x - xPosition * CHUNK_SIZE_X;
         int y = tileEntity.y;
         int z = tileEntity.z - zPosition * CHUNK_SIZE_Z;
-        setBlockEntity(x, y, z, tileEntity);
+        setTileEntity(x, y, z, tileEntity);
         if(isLoaded)
         {
             world.loadedTileEntityList.add(tileEntity);
@@ -529,7 +529,7 @@ public class Chunk
     /**
      * @return True if the specified block entity was set
      */
-    public boolean setBlockEntity(int x, int y, int z, TileEntity tileEntity)
+    public boolean setTileEntity(int x, int y, int z, TileEntity tileEntity)
     {
         ChunkPosition chunkposition = new ChunkPosition(x, y, z);
         tileEntity.worldObj = world;
@@ -545,7 +545,7 @@ public class Chunk
         else
         {
             tileEntity.validate();
-            TileEntity previous = blockEntityMap.put(chunkposition, tileEntity);
+            TileEntity previous = tileEntityMap.put(chunkposition, tileEntity);
             if (previous != null) {
                 previous.invalidate();
             }
@@ -554,12 +554,12 @@ public class Chunk
         return false;
     }
 
-    public void removeBlockEntity(int x, int y, int z)
+    public void removeTileEntity(int x, int y, int z)
     {
         ChunkPosition pos = new ChunkPosition(x, y, z);
         if(isLoaded)
         {
-            TileEntity tileEntity = blockEntityMap.remove(pos);
+            TileEntity tileEntity = tileEntityMap.remove(pos);
             if(tileEntity != null)
             {
                 tileEntity.invalidate();
@@ -567,9 +567,9 @@ public class Chunk
         }
     }
 
-    public void removeBlockEntity(TileEntity tileEntity) {
-        if (isLoaded && tileEntity != null && blockEntityMap.containsValue(tileEntity)) {
-            blockEntityMap.remove(new ChunkPosition(tileEntity.x & (Chunk.CHUNK_SIZE_X - 1), tileEntity.y, tileEntity.z & (Chunk.CHUNK_SIZE_Z - 1)));
+    public void removeTileEntity(TileEntity tileEntity) {
+        if (isLoaded && tileEntity != null && tileEntityMap.containsValue(tileEntity)) {
+            tileEntityMap.remove(new ChunkPosition(tileEntity.x & (Chunk.CHUNK_SIZE_X - 1), tileEntity.y, tileEntity.z & (Chunk.CHUNK_SIZE_Z - 1)));
             tileEntity.invalidate();
         }
     }
@@ -577,7 +577,7 @@ public class Chunk
     public void onLoad()
     {
         isLoaded = true;
-        world.addAllBlockEntities(blockEntityMap.values());
+        world.addAllBlockEntities(tileEntityMap.values());
 
         for (ChunkSection section : sections) {
             section.onLoad(world);
@@ -588,7 +588,7 @@ public class Chunk
     {
         isLoaded = false;
         TileEntity tileentity;
-        for(Iterator<TileEntity> iterator = blockEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate())
+        for(Iterator<TileEntity> iterator = tileEntityMap.values().iterator(); iterator.hasNext(); tileentity.invalidate())
         {
             tileentity = iterator.next();
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index c2bc4d8d7..178a006c3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -71,11 +71,11 @@ public class ChunkCache
     }
 
     @Override
-	public TileEntity getBlockEntity(int x, int y, int z)
+	public TileEntity getTileEntity(int x, int y, int z)
     {
         int l = Math.floorDiv(x, Chunk.CHUNK_SIZE_X) - chunkX;
         int i1 = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z) - chunkZ;
-        return chunkArray[l][i1].getBlockEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+        return chunkArray[l][i1].getTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
     }
 
     public boolean getBlockLitInteriorSurface(int x, int y, int z)
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 8069fefad..e78616393 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -206,7 +206,7 @@ public class ChunkLoaderLegacy
         // Write tile entities
         ListTag tileEntityListTag = new ListTag();
         CompoundTag tileEntityTag;
-        for (TileEntity tileEntity : chunk.blockEntityMap.values())
+        for (TileEntity tileEntity : chunk.tileEntityMap.values())
         {
             tileEntityTag = new CompoundTag();
             tileEntity.writeToNBT(tileEntityTag);
@@ -307,7 +307,7 @@ public class ChunkLoaderLegacy
                     TileEntity tileEntity = TileEntityDispatcher.createAndLoadEntity(tileEntityTag);
                     if (tileEntity != null)
                     {
-                        chunk.addBlockEntity(tileEntity);
+                        chunk.addTileEntity(tileEntity);
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
index e0eea2729..977789001 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/DisplayChunk.java
@@ -36,7 +36,7 @@ public class DisplayChunk extends EmptyChunk{
         return 15;
     }
     @Override
-    public boolean setBlockEntity(int x, int y, int z, TileEntity tileEntity)
+    public boolean setTileEntity(int x, int y, int z, TileEntity tileEntity)
     {
         if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
             displayTileEntity = tileEntity;
@@ -49,14 +49,14 @@ public class DisplayChunk extends EmptyChunk{
     }
 
     @Override
-    public void removeBlockEntity(int x, int y, int z)
+    public void removeTileEntity(int x, int y, int z)
     {
         if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
             displayTileEntity = null;
         }
     }
     @Override
-    public TileEntity getBlockEntity(int x, int y, int z)
+    public TileEntity getTileEntity(int x, int y, int z)
     {
         if (x == displayBlockPosX && y == displayBlockPosY && z == displayBlockPosZ){
             return displayTileEntity;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index 1481d1491..c1aa0b772 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -116,24 +116,24 @@ public class EmptyChunk extends Chunk
     }
 
     @Override
-	public TileEntity getBlockEntity(int x, int y, int z)
+	public TileEntity getTileEntity(int x, int y, int z)
     {
         return null;
     }
 
     @Override
-	public void addBlockEntity(TileEntity tileEntity)
+	public void addTileEntity(TileEntity tileEntity)
     {
     }
 
     @Override
-	public boolean setBlockEntity(int x, int y, int z, TileEntity tileEntity)
+	public boolean setTileEntity(int x, int y, int z, TileEntity tileEntity)
     {
         return false;
     }
 
     @Override
-	public void removeBlockEntity(int x, int y, int z)
+	public void removeTileEntity(int x, int y, int z)
     {
     }
 
